Index: codes/icosagcm/trunk/src/etat0.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0.f90	(revision 294)
+++ codes/icosagcm/trunk/src/etat0.f90	(revision 295)
@@ -25,6 +25,4 @@
     USE etat0_dcmip4_mod, ONLY : etat0_dcmip4=>etat0  
     USE etat0_heldsz_mod, ONLY : etat0_heldsz=>etat0  
-    USE dynetat0_gcm_mod, ONLY : dynetat0_start=>etat0 
-    USE dynetat0_hz_mod,  ONLY : dynetat0_hz=>etat0 
     USE etat0_start_file_mod, ONLY : etat0_start_file=>etat0  
 
@@ -80,5 +78,5 @@
     CASE ('dcmip3')
        CALL etat0_dcmip3(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
-     CASE ('dcmip4')
+    CASE ('dcmip4')
         IF(nqtot<2) THEN
            IF (is_mpi_root)  THEN
@@ -87,11 +85,5 @@
            STOP
         END IF
-       CALL etat0_dcmip4(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
-     CASE ('readnf_start') 
-	  print*,"readnf_start used"	
-       CALL dynetat0_start(f_ps,f_phis,f_theta_rhodz,f_u,f_q) 
-	CASE ('readnf_hz') 
-	  print*,"readnf_hz used"
-       CALL dynetat0_hz(f_ps,f_phis,f_theta_rhodz,f_u,f_q) 
+        CALL etat0_dcmip4(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
    CASE DEFAULT
        PRINT*, 'Bad selector for variable etat0 <',etat0_type, &
@@ -114,4 +106,5 @@
 
   SUBROUTINE etat0_collocated(f_phis,f_ps,f_mass,f_theta_rhodz,f_u, f_q)
+    USE theta2theta_rhodz_mod
     IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
@@ -119,4 +112,5 @@
     TYPE(t_field),POINTER :: f_phis(:)
     TYPE(t_field),POINTER :: f_theta_rhodz(:)
+    TYPE(t_field),POINTER :: f_temp(:)
     TYPE(t_field),POINTER :: f_u(:)
     TYPE(t_field),POINTER :: f_q(:)
@@ -126,4 +120,5 @@
     REAL(rstd),POINTER :: phis(:)
     REAL(rstd),POINTER :: theta_rhodz(:,:)
+    REAL(rstd),POINTER :: temp(:,:)
     REAL(rstd),POINTER :: u(:,:)
     REAL(rstd),POINTER :: q(:,:,:)
@@ -138,12 +133,21 @@
       phis=f_phis(ind)
       theta_rhodz=f_theta_rhodz(ind)
+      temp=f_temp(ind)
       u=f_u(ind)
       q=f_q(ind)
-      CALL compute_etat0_collocated(ps,mass, phis, theta_rhodz, u, q)
+
+      IF( TRIM(etat0_type)=='williamson91.6' ) THEN 
+       CALL compute_etat0_collocated(ps,mass, phis, theta_rhodz, u, q)
+      ELSE
+       CALL compute_etat0_collocated(ps,mass, phis, temp, u, q)
+      ENDIF
     ENDDO
+    
+    IF( TRIM(etat0_type)/='williamson91.6' ) CALL temperature2theta_rhodz(f_ps,f_temp,f_theta_rhodz)
+    
+    
   END SUBROUTINE etat0_collocated
 
-  SUBROUTINE compute_etat0_collocated(ps,mass, phis, theta_rhodz, u, q)
-    USE theta2theta_rhodz_mod
+  SUBROUTINE compute_etat0_collocated(ps,mass, phis, temp_i, u, q)
     USE wind_mod
     USE etat0_jablonowsky06_mod, ONLY : compute_jablonowsky06 => compute_etat0
@@ -154,12 +158,15 @@
     REAL(rstd),INTENT(INOUT) :: mass(iim*jjm,llm)
     REAL(rstd),INTENT(OUT) :: phis(iim*jjm)
-    REAL(rstd),INTENT(OUT) :: theta_rhodz(iim*jjm,llm)
+    REAL(rstd),INTENT(OUT) :: temp_i(iim*jjm,llm)
     REAL(rstd),INTENT(OUT) :: u(3*iim*jjm,llm)
     REAL(rstd),INTENT(OUT) :: q(iim*jjm,llm,nqtot)
 
-    REAL(rstd) :: temp_i(iim*jjm,llm)
+    REAL(rstd) :: lon_i(iim*jjm)
+    REAL(rstd) :: lat_i(iim*jjm)
     REAL(rstd) :: ulon_i(iim*jjm,llm)
     REAL(rstd) :: ulat_i(iim*jjm,llm)
 
+    REAL(rstd) :: lon_e(3*iim*jjm)
+    REAL(rstd) :: lat_e(3*iim*jjm)
     REAL(rstd) :: ps_e(3*iim*jjm)
     REAL(rstd) :: mass_e(3*iim*jjm,llm)
@@ -183,15 +190,8 @@
        CALL compute_dcmip5(3*iim*jjm,lon_e,lat_e, phis_e, ps_e, temp_e, ulon_e, ulat_e, q_e)
     CASE('williamson91.6')
-       CALL compute_w91_6(iim*jjm,lon_i,lat_i, phis, mass(:,1), theta_rhodz(:,1), ulon_i(:,1), ulat_i(:,1))
+       CALL compute_w91_6(iim*jjm,lon_i,lat_i, phis, mass(:,1), temp_i(:,1), ulon_i(:,1), ulat_i(:,1))
        CALL compute_w91_6(3*iim*jjm,lon_e,lat_e, phis_e, mass_e(:,1), temp_e(:,1), ulon_e(:,1), ulat_e(:,1))
     END SELECT
 
-    SELECT CASE (TRIM(etat0_type))
-    CASE('williamson91.6')
-       ! Do nothing
-    CASE DEFAULT
-       CALL compute_temperature2theta_rhodz(ps,temp_i,theta_rhodz,0)    
-    END SELECT
- 
     CALL compute_wind_perp_from_lonlat_compound(ulon_e, ulat_e, u)
 
Index: codes/icosagcm/trunk/src/etat0_academic.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_academic.f90	(revision 294)
+++ codes/icosagcm/trunk/src/etat0_academic.f90	(revision 295)
@@ -134,6 +134,9 @@
      
 
+!$OMP BARRIER
     CALL compute_pression(ps,p,1)     
+!$OMP BARRIER
     CALL compute_exner(ps,p,pks,pk,1)  
+!$OMP BARRIER
     CALL compute_geopotential(phis,pks,pk,theta,phi,1)
 
Index: codes/icosagcm/trunk/src/etat0_dcmip2.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_dcmip2.f90	(revision 294)
+++ codes/icosagcm/trunk/src/etat0_dcmip2.f90	(revision 295)
@@ -14,4 +14,5 @@
   SUBROUTINE etat0(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
   USE icosa
+  USE theta2theta_rhodz_mod
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
@@ -20,9 +21,10 @@
     TYPE(t_field),POINTER :: f_u(:)
     TYPE(t_field),POINTER :: f_q(:)
-    
+        
+    TYPE(t_field),POINTER,SAVE :: f_temp(:)
     REAL(rstd),POINTER :: ps(:)
     REAL(rstd),POINTER :: phis(:)
     REAL(rstd),POINTER :: u(:,:)
-    REAL(rstd),POINTER :: theta_rhodz(:,:)
+    REAL(rstd),POINTER :: Temp(:,:)
     REAL(rstd),POINTER :: q(:,:,:)
 
@@ -45,4 +47,6 @@
     PRINT *, 'Orographic gravity-wave test case :', TRIM(etat0_type)
 
+    CALL allocate_field(f_temp,field_t,type_real,llm,name='temp') 
+
     DO ind=1,ndomain
       IF (.NOT. assigned_domain(ind)) CYCLE
@@ -53,12 +57,16 @@
       phis=f_phis(ind)
       u=f_u(ind)
-      theta_rhodz=f_theta_rhodz(ind)
       q=f_q(ind)
-      CALL compute_etat0_DCMIP2(icase,ps,phis,u,theta_rhodz,q)
+      temp=f_temp(ind)
+      CALL compute_etat0_DCMIP2(icase,ps,phis,u,Temp,q)
     ENDDO
+    
+    CALL temperature2theta_rhodz(f_ps,f_temp,f_theta_rhodz)
             
+    CALL deallocate_field(f_temp)
+   
   END SUBROUTINE etat0
   
-  SUBROUTINE compute_etat0_DCMIP2(icase, ps, phis, u, theta_rhodz,q)
+  SUBROUTINE compute_etat0_DCMIP2(icase, ps, phis, u, temp,q)
     USE icosa
     USE disvert_mod, ONLY : ap,bp
@@ -71,7 +79,7 @@
     REAL(rstd), INTENT(OUT) :: phis(iim*jjm)
     REAL(rstd), INTENT(OUT) :: u(3*iim*jjm,llm)
-    REAL(rstd), INTENT(OUT) :: theta_rhodz(iim*jjm,llm)
+    REAL(rstd), INTENT(OUT) :: temp(iim*jjm,llm)
     REAL(rstd), INTENT(OUT) :: q(iim*jjm,llm)
-    REAL(rstd) :: ulon(3*iim*jjm,llm), ulat(3*iim*jjm,llm), temp(iim*jjm,llm)
+    REAL(rstd) :: ulon(3*iim*jjm,llm), ulat(3*iim*jjm,llm)
     
     INTEGER :: i,j,l,ij
@@ -90,5 +98,4 @@
        END DO
     END DO
-    CALL compute_temperature2theta_rhodz(ps,temp,theta_rhodz,1)
     
     ! Edges : ulon,ulat
Index: codes/icosagcm/trunk/src/etat0_dcmip3.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_dcmip3.f90	(revision 294)
+++ codes/icosagcm/trunk/src/etat0_dcmip3.f90	(revision 295)
@@ -18,4 +18,5 @@
   SUBROUTINE etat0(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
   USE icosa
+  USE theta2theta_rhodz_mod
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
@@ -24,12 +25,15 @@
     TYPE(t_field),POINTER :: f_u(:)
     TYPE(t_field),POINTER :: f_q(:)
+    TYPE(t_field),POINTER,SAVE :: f_temp(:)
     
     REAL(rstd),POINTER :: ps(:)
     REAL(rstd),POINTER :: phis(:)
     REAL(rstd),POINTER :: u(:,:)
-    REAL(rstd),POINTER :: theta_rhodz(:,:)
+    REAL(rstd),POINTER :: Temp(:,:)
     REAL(rstd),POINTER :: q(:,:,:)
 
     INTEGER :: ind
+
+    CALL allocate_field(f_temp,field_t,type_real,llm,name='temp') 
 
     DO ind=1,ndomain
@@ -41,13 +45,16 @@
       phis=f_phis(ind)
       u=f_u(ind)
-      theta_rhodz=f_theta_rhodz(ind)
       q=f_q(ind)
-      CALL compute_etat0_DCMIP3(ps,phis,u,theta_rhodz,q)
+      temp=f_temp(ind)
+      CALL compute_etat0_DCMIP3(ps,phis,u,Temp,q)
     ENDDO
+
+    CALL temperature2theta_rhodz(f_ps,f_temp,f_theta_rhodz)
+    CALL deallocate_field(f_temp)
             
   END SUBROUTINE etat0
   
 
-  SUBROUTINE compute_etat0_DCMIP3(ps, phis, u, theta_rhodz,q)
+  SUBROUTINE compute_etat0_DCMIP3(ps, phis, u, temp,q)
   USE icosa
   USE pression_mod
@@ -68,10 +75,9 @@
   REAL(rstd), INTENT(OUT) :: phis(iim*jjm)
   REAL(rstd), INTENT(OUT) :: u(3*iim*jjm,llm)
-  REAL(rstd), INTENT(OUT) :: theta_rhodz(iim*jjm,llm)
+  REAL(rstd), INTENT(OUT) :: Temp(iim*jjm,llm)
   REAL(rstd), INTENT(OUT) :: q(iim*jjm,llm,nqtot)
   
   REAL(rstd) :: Ts(iim*jjm)
   REAL(rstd) :: s(iim*jjm)
-  REAL(rstd) :: T(iim*jjm,llm)
   REAL(rstd) :: p(iim*jjm,llm+1)
   REAL(rstd) :: theta(iim*jjm,llm)
@@ -125,5 +131,7 @@
   END DO
   
+!$OMP BARRIER
   CALL compute_pression(ps,p,0)
+!$OMP BARRIER
   
   DO l=1,llm
@@ -134,5 +142,5 @@
            IF(use_dcmip_routine) THEN
               CALL test3_gravity_wave(lon_i(ij),lat_i(ij),pp,dummy,0, &
-                   dummy,dummy,dummy,T(ij,l),dummy,dummy,dummy,dummy)
+                   dummy,dummy,dummy,Temp(ij,l),dummy,dummy,dummy,dummy)
            ELSE
               pspsk=(pp/ps(ij))**kappa
@@ -142,5 +150,5 @@
               thetap = dtheta *sin(2*Pi*zz/Lz) * s(ij)                ! perturbation pot. temp.
               theta(ij,l) = thetab + thetap
-              T(ij,l) = theta(ij,l)* ((pp/peq)**kappa)
+              Temp(ij,l) = theta(ij,l)* ((pp/peq)**kappa)
               ! T(ij,l) = Ts(ij)*pspsk / ( Ts(ij) / GG * ( pspsk-1) +1)  ! background temp.
            END IF
@@ -149,9 +157,9 @@
   ENDDO
   
-  IF(use_dcmip_routine) THEN
-     CALL compute_temperature2theta_rhodz(ps,T,theta_rhodz,0)
-  ELSE
-     CALL compute_temperature2theta_rhodz(ps,T,theta_rhodz,0)
-  END IF
+!  IF(use_dcmip_routine) THEN
+!     CALL compute_temperature2theta_rhodz(ps,T,theta_rhodz,0)
+!  ELSE
+!     CALL compute_temperature2theta_rhodz(ps,T,theta_rhodz,0)
+!  END IF
   
   pp=peq
Index: codes/icosagcm/trunk/src/exner.f90
===================================================================
--- codes/icosagcm/trunk/src/exner.f90	(revision 294)
+++ codes/icosagcm/trunk/src/exner.f90	(revision 295)
@@ -22,4 +22,5 @@
     INTEGER :: ind
 
+!$OMP BARRIER
     DO ind=1,ndomain
       IF (.NOT. assigned_domain(ind)) CYCLE
@@ -32,4 +33,5 @@
       CALL compute_exner(ps, p, pks, pk, 0)
     ENDDO
+!$OMP BARRIER
   
   END SUBROUTINE exner
@@ -39,4 +41,5 @@
   USE disvert_mod
   USE pression_mod
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: ps(iim*jjm)
@@ -52,66 +55,74 @@
        !! Compute Alpha and Beta
        
+       IF (is_omp_level_master) THEN
        ! for llm layer
-       DO j=jj_begin-offset,jj_end+offset
-          DO i=ii_begin-offset,ii_end+offset
-             ij=(j-1)*iim+i
-             alpha(ij,llm) = 0.
-             beta (ij,llm) = 1./ (1+ 2*kappa)
-          ENDDO
-       ENDDO
+         DO j=jj_begin-offset,jj_end+offset
+            DO i=ii_begin-offset,ii_end+offset
+               ij=(j-1)*iim+i
+               alpha(ij,llm) = 0.
+               beta (ij,llm) = 1./ (1+ 2*kappa)
+            ENDDO
+         ENDDO
        
        ! for other layer   
-       DO l = llm-1 , 2 , -1
+         DO l = llm-1 , 2 , -1
+            DO j=jj_begin-offset,jj_end+offset
+               DO i=ii_begin-offset,ii_end+offset
+                  ij=(j-1)*iim+i
+                  delta = p(ij,l)* (1+2*kappa) + p(ij,l+1)* ( beta(ij,l+1)- (1+2*kappa) )
+                  alpha(ij,l)  = - p(ij,l+1) / delta * alpha(ij,l+1)
+                  beta (ij,l)  =   p(ij,l  ) / delta   
+               ENDDO
+            ENDDO
+         ENDDO
+       
+         !! Compute pk
+       
+         ! for first layer
+         DO j=jj_begin-offset,jj_end+offset
+            DO i=ii_begin-offset,ii_end+offset
+               ij=(j-1)*iim+i
+               pks(ij) = cpp * ( ps(ij)/preff ) ** kappa
+               pk(ij,1) = ( p(ij,1)*pks(ij) - 0.5*alpha(ij,2)*p(ij,2) )     /    &
+                    (  p(ij,1)* (1.+kappa) + 0.5*( beta(ij,2)-(1.+2*kappa) )* p(ij,2) )
+            ENDDO
+         ENDDO
+       
+       ! for other layers
+       
+         DO l = 2, llm
+            DO j=jj_begin-offset,jj_end+offset
+               DO i=ii_begin-offset,ii_end+offset
+                  ij=(j-1)*iim+i
+                  pk(ij,l) = alpha(ij,l) + beta(ij,l) * pk(ij,l-1)
+               ENDDO
+            ENDDO
+         ENDDO
+
+       ENDIF
+
+    ELSE ! Simple calculation of Exner pressure based on centered average
+       ! surface : pks
+       IF (is_omp_level_master) THEN
+
+         DO j=jj_begin-offset,jj_end+offset
+            DO i=ii_begin-offset,ii_end+offset
+               ij=(j-1)*iim+i
+               pks(ij) = cpp * ( ps(ij)/preff ) ** kappa
+            ENDDO
+         ENDDO
+
+       ENDIF
+
+         ! 3D : pk
+       DO l = 1, llm
           DO j=jj_begin-offset,jj_end+offset
              DO i=ii_begin-offset,ii_end+offset
-                ij=(j-1)*iim+i
-                delta = p(ij,l)* (1+2*kappa) + p(ij,l+1)* ( beta(ij,l+1)- (1+2*kappa) )
-                alpha(ij,l)  = - p(ij,l+1) / delta * alpha(ij,l+1)
-                beta (ij,l)  =   p(ij,l  ) / delta   
+               ij=(j-1)*iim+i
+               pk(ij,l) = cpp * ((.5/preff)*(p(ij,l)+p(ij,l+1))) ** kappa
              ENDDO
           ENDDO
        ENDDO
-       
-       !! Compute pk
-       
-       ! for first layer
-       DO j=jj_begin-offset,jj_end+offset
-          DO i=ii_begin-offset,ii_end+offset
-             ij=(j-1)*iim+i
-             pks(ij) = cpp * ( ps(ij)/preff ) ** kappa
-             pk(ij,1) = ( p(ij,1)*pks(ij) - 0.5*alpha(ij,2)*p(ij,2) )     /    &
-                  (  p(ij,1)* (1.+kappa) + 0.5*( beta(ij,2)-(1.+2*kappa) )* p(ij,2) )
-          ENDDO
-       ENDDO
-       
-       ! for other layers
-       
-       DO l = 2, llm
-          DO j=jj_begin-offset,jj_end+offset
-             DO i=ii_begin-offset,ii_end+offset
-                ij=(j-1)*iim+i
-                pk(ij,l) = alpha(ij,l) + beta(ij,l) * pk(ij,l-1)
-             ENDDO
-          ENDDO
-       ENDDO
-       
-    ELSE ! Simple calculation of Exner pressure based on centered average
-       ! surface : pks
-       DO j=jj_begin-offset,jj_end+offset
-          DO i=ii_begin-offset,ii_end+offset
-             ij=(j-1)*iim+i
-             pks(ij) = cpp * ( ps(ij)/preff ) ** kappa
-          ENDDO
-       ENDDO
 
-       ! 3D : pk
-       DO l = 1, llm
-          DO j=jj_begin-offset,jj_end+offset
-             DO i=ii_begin-offset,ii_end+offset
-                ij=(j-1)*iim+i
-                pk(ij,l) = cpp * ((.5/preff)*(p(ij,l)+p(ij,l+1))) ** kappa
-             ENDDO
-          ENDDO
-       ENDDO
     END IF
     
Index: codes/icosagcm/trunk/src/field.f90
===================================================================
--- codes/icosagcm/trunk/src/field.f90	(revision 294)
+++ codes/icosagcm/trunk/src/field.f90	(revision 295)
@@ -48,4 +48,5 @@
   SUBROUTINE allocate_field(field,field_type,data_type,dim1,dim2,name)
   USE domain_mod
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: field(:)
@@ -64,5 +65,5 @@
 
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master) CYCLE
 
       IF(PRESENT(name)) THEN
@@ -181,4 +182,5 @@
   SUBROUTINE deallocate_field(field)
   USE domain_mod
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: field(:)
@@ -188,5 +190,5 @@
 !$OMP BARRIER
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master) CYCLE
 
       data_type=field(ind)%data_type
Index: codes/icosagcm/trunk/src/geometry.f90
===================================================================
--- codes/icosagcm/trunk/src/geometry.f90	(revision 294)
+++ codes/icosagcm/trunk/src/geometry.f90	(revision 295)
@@ -166,4 +166,5 @@
     USE vector
     USE transfert_mod
+    USE omp_para
 
     IMPLICIT NONE
@@ -186,5 +187,5 @@
     
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -212,4 +213,5 @@
   USE vector
   USE getin_mod
+  USE omp_para
   IMPLICIT NONE
     INTEGER :: nb_it=0
@@ -226,5 +228,5 @@
     
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master) CYCLE
       d=>domain(ind)
       CALL swap_dimensions(ind)
@@ -241,5 +243,5 @@
 
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master ) CYCLE
       d=>domain(ind)
       CALL swap_dimensions(ind)
@@ -271,5 +273,5 @@
       sum=0
       DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master ) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -311,4 +313,5 @@
   USE transfert_mod
   USE getin_mod
+  USE omp_para
   IMPLICIT NONE
 
@@ -330,5 +333,5 @@
  
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master ) CYCLE
       d=>domain(ind)
       CALL swap_dimensions(ind)
@@ -559,5 +562,5 @@
     CALL transfert_request(geom%centroid,req_i1)
 
-    CALL surf_triangle(d%xyz(:,ii_begin,jj_begin),d%xyz(:,ii_begin,jj_end),d%xyz(:,ii_end,jj_begin),S)
+!    CALL surf_triangle(d%xyz(:,ii_begin,jj_begin),d%xyz(:,ii_begin,jj_end),d%xyz(:,ii_end,jj_begin),S)
  
   END SUBROUTINE set_geometry
Index: codes/icosagcm/trunk/src/geopotential_mod.f90
===================================================================
--- codes/icosagcm/trunk/src/geopotential_mod.f90	(revision 294)
+++ codes/icosagcm/trunk/src/geopotential_mod.f90	(revision 295)
@@ -35,4 +35,5 @@
   SUBROUTINE compute_geopotential(phis,pks,pk,theta,phi,offset)
   USE icosa
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: phis(iim*jjm)
@@ -51,21 +52,28 @@
    
   ! for first layer
-   DO j=jj_begin-offset,jj_end+offset
-     DO i=ii_begin-offset,ii_end+offset
-       ij=(j-1)*iim+i
-       phi( ij,1 ) = phis( ij ) + theta(ij,1) * ( pks(ij) - pk(ij,1) )
-     ENDDO
-   ENDDO
-          
-  ! for other layers
-   DO l = 2, llm
+
+! flush pks, pk thetha, phis
+!$OMP BARRIER
+   IF(is_omp_level_master) THEN
      DO j=jj_begin-offset,jj_end+offset
        DO i=ii_begin-offset,ii_end+offset
          ij=(j-1)*iim+i
-         phi(ij,l) = phi(ij,l-1) + 0.5 * ( theta(ij,l)  + theta(ij,l-1) )  & 
-                                       * (  pk(ij,l-1) -  pk(ij,l)    )
+         phi( ij,1 ) = phis( ij ) + theta(ij,1) * ( pks(ij) - pk(ij,1) )
        ENDDO
      ENDDO
-   ENDDO
+          
+    ! for other layers
+     DO l = 2, llm
+       DO j=jj_begin-offset,jj_end+offset
+         DO i=ii_begin-offset,ii_end+offset
+           ij=(j-1)*iim+i
+           phi(ij,l) = phi(ij,l-1) + 0.5 * ( theta(ij,l)  + theta(ij,l-1) )  & 
+                                         * (  pk(ij,l-1) -  pk(ij,l)    )
+         ENDDO
+       ENDDO
+     ENDDO
+   ENDIF
+! flush phi
+!$OMP BARRIER
    
   END SUBROUTINE compute_geopotential
Index: codes/icosagcm/trunk/src/icosa_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/icosa_gcm.f90	(revision 294)
+++ codes/icosagcm/trunk/src/icosa_gcm.f90	(revision 295)
@@ -19,6 +19,6 @@
   CALL xios_init
   CALL init_earth_const 
-  CALL init_grid_param(is_mpi_root)
-  CALL init_omp_para
+  CALL init_grid_param(is_mpi_master)
+  CALL init_omp_para(is_mpi_master)
   CALL compute_metric
   CALL compute_domain
@@ -28,4 +28,5 @@
 
 !$OMP PARALLEL  
+  CALL switch_omp_no_distrib_level
   CALL compute_geometry
   CALL check_total_area
@@ -43,5 +44,5 @@
   
   CALL timeloop
-
+  CALL switch_omp_no_distrib_level
 !$OMP END PARALLEL
 
Index: codes/icosagcm/trunk/src/kinetic.f90
===================================================================
--- codes/icosagcm/trunk/src/kinetic.f90	(revision 294)
+++ codes/icosagcm/trunk/src/kinetic.f90	(revision 295)
@@ -30,4 +30,5 @@
   SUBROUTINE compute_kinetic(ue, Ki)
   USE icosa
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: ue(3*iim*jjm,llm)
@@ -35,5 +36,5 @@
     INTEGER :: i,j,ij,l
     
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
Index: codes/icosagcm/trunk/src/omega.f90
===================================================================
--- codes/icosagcm/trunk/src/omega.f90	(revision 294)
+++ codes/icosagcm/trunk/src/omega.f90	(revision 295)
@@ -23,6 +23,10 @@
   END SUBROUTINE W_omega
 
+
+
   SUBROUTINE compute_omega(ps,u, w)
     USE disvert_mod, ONLY : ap,bp
+    USE omp_para
+    IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: u(iim*3*jjm,llm), ps(iim*jjm)
     REAL(rstd),INTENT(OUT):: w(iim*jjm,llm)
@@ -30,63 +34,68 @@
     REAL(rstd):: p(iim*jjm,llm+1), rhodz(iim*jjm,llm), Fe(iim*3*jjm,llm)
     REAL(rstd):: ugradps
-    DO    l    = 1, llm+1
-       DO j=jj_begin-1,jj_end+1
-          DO i=ii_begin-1,ii_end+1
-             ij=(j-1)*iim+i
-             p(ij,l) = ap(l) + bp(l) * ps(ij)
-          ENDDO
-       ENDDO
-    ENDDO
+    
+    INTEGER :: i,j,l,ij
+
+!$OMP BARRIER    
+    IF (is_omp_level_master) THEN
+      DO    l    = 1, llm+1
+         DO j=jj_begin-1,jj_end+1
+           DO i=ii_begin-1,ii_end+1
+               ij=(j-1)*iim+i
+               p(ij,l) = ap(l) + bp(l) * ps(ij)
+            ENDDO
+         ENDDO
+      ENDDO
     
 !!! Compute mass
-    DO l = 1, llm
-       DO j=jj_begin-1,jj_end+1
-          DO i=ii_begin-1,ii_end+1
-             ij=(j-1)*iim+i
-             rhodz(ij,l) = ( p(ij,l) - p(ij,l+1) ) / g
-          ENDDO
-       ENDDO
-    ENDDO
+      DO l = 1, llm
+         DO j=jj_begin-1,jj_end+1
+            DO i=ii_begin-1,ii_end+1
+               ij=(j-1)*iim+i
+               rhodz(ij,l) = ( p(ij,l) - p(ij,l+1) ) / g
+            ENDDO
+         ENDDO
+      ENDDO
     
 !!!  Compute mass flux
-    DO l = 1, llm
-       DO j=jj_begin-1,jj_end+1
-          DO i=ii_begin-1,ii_end+1
-             ij=(j-1)*iim+i
-             Fe(ij+u_right,l)=0.5*(rhodz(ij,l)+rhodz(ij+t_right,l))*u(ij+u_right,l)*le(ij+u_right)
-             Fe(ij+u_lup,l)=0.5*(rhodz(ij,l)+rhodz(ij+t_lup,l))*u(ij+u_lup,l)*le(ij+u_lup)
-             Fe(ij+u_ldown,l)=0.5*(rhodz(ij,l)+rhodz(ij+t_ldown,l))*u(ij+u_ldown,l)*le(ij+u_ldown)
-          ENDDO
-       ENDDO
-    ENDDO
+      DO l = 1, llm
+         DO j=jj_begin-1,jj_end+1
+            DO i=ii_begin-1,ii_end+1
+               ij=(j-1)*iim+i
+               Fe(ij+u_right,l)=0.5*(rhodz(ij,l)+rhodz(ij+t_right,l))*u(ij+u_right,l)*le(ij+u_right)
+               Fe(ij+u_lup,l)=0.5*(rhodz(ij,l)+rhodz(ij+t_lup,l))*u(ij+u_lup,l)*le(ij+u_lup)
+               Fe(ij+u_ldown,l)=0.5*(rhodz(ij,l)+rhodz(ij+t_ldown,l))*u(ij+u_ldown,l)*le(ij+u_ldown)
+            ENDDO
+         ENDDO
+      ENDDO
     
 !!! mass flux convergence computation  
     
     ! horizontal convergence
-    DO l = 1, llm
-       DO j=jj_begin,jj_end
-          DO i=ii_begin,ii_end
-             ij=(j-1)*iim+i
-             ! convm = +div(mass flux), sign convention as in Ringler et al. 2012, eq. 21
-             convm(ij,l)= 1./Ai(ij)*(ne(ij,right)*Fe(ij+u_right,l)   +  &
-                  ne(ij,rup)*Fe(ij+u_rup,l)       +  &  
-                  ne(ij,lup)*Fe(ij+u_lup,l)       +  &  
-                  ne(ij,left)*Fe(ij+u_left,l)     +  &  
-                  ne(ij,ldown)*Fe(ij+u_ldown,l)   +  &  
-                  ne(ij,rdown)*Fe(ij+u_rdown,l))
-          ENDDO
-       ENDDO
-    ENDDO
+      DO l = 1, llm
+         DO j=jj_begin,jj_end
+            DO i=ii_begin,ii_end
+               ij=(j-1)*iim+i
+               ! convm = +div(mass flux), sign convention as in Ringler et al. 2012, eq. 21
+               convm(ij,l)= 1./Ai(ij)*(ne(ij,right)*Fe(ij+u_right,l)   +  &
+                    ne(ij,rup)*Fe(ij+u_rup,l)       +  &  
+                    ne(ij,lup)*Fe(ij+u_lup,l)       +  &  
+                    ne(ij,left)*Fe(ij+u_left,l)     +  &  
+                    ne(ij,ldown)*Fe(ij+u_ldown,l)   +  &  
+                    ne(ij,rdown)*Fe(ij+u_rdown,l))
+            ENDDO
+         ENDDO
+      ENDDO
     
-    ! vertical integration from up to down
-    DO  l = llm-1, 1, -1
-       DO j=jj_begin,jj_end
-          DO i=ii_begin,ii_end
-             ij=(j-1)*iim+i
-             convm(ij,l) = convm(ij,l) + convm(ij,l+1)
-          ENDDO
-       ENDDO
-    ENDDO
-    convm(:,llm+1)=0.
+      ! vertical integration from up to down
+      DO  l = llm-1, 1, -1
+         DO j=jj_begin,jj_end
+            DO i=ii_begin,ii_end
+               ij=(j-1)*iim+i
+               convm(ij,l) = convm(ij,l) + convm(ij,l+1)
+            ENDDO
+         ENDDO
+      ENDDO
+      convm(:,llm+1)=0.
 
 !!! Compute dps
@@ -125,8 +134,7 @@
     ! -grad ps : ( ne(ij,ldown)*ps(ij,l) + ne(ij+t_ldown,rup)*ps(ij+t_ldown,l) ) ) / de(ij+u_ldown)
 
-    DO l = 1,llm
-       DO j=jj_begin,jj_end
-          DO i=ii_begin,ii_end
-             toto = 1
+       DO l = 1,llm
+         DO j=jj_begin,jj_end 
+           DO i=ii_begin,ii_end
              ij=(j-1)*iim+i
              ugradps = &
@@ -140,6 +148,8 @@
              w( ij, l) =  ugradps - .5*(convm( ij,l+1)+convm(ij,l)) 
           ENDDO
-       ENDDO
-    ENDDO
+        ENDDO
+      ENDDO
+    ENDIF
+!$OMP BARRIER
     
   END SUBROUTINE compute_omega
